package main

import ("path"; "os")

type Path string

// kielegiti az exp/iterable.Iterable interface-t
func (p Path) Iter() <-chan Path {
	// ez az eredmeny csatornank
	c := make(chan Path)
	
	// ez a goroutine rekurzivan bejarja a path-et es bezarja ezt a csatornat
	go func() { 
		path.Walk(p.String(), pathIter(c), nil)
		close(c)
	}();
	
	// visszaadjuk az eredmeny csatornat
	return c
}

type pathIter chan<- Path

// path.Visitor interface definicio
func (c pathIter) VisitDir(path string, d *os.FileInfo) bool {
	return path[0] != '.'
}

func (c pathIter) VisitFile(path string, d *os.FileInfo) {
	c <- Path(path)
}

// csak egy tipuskonverzio
func (p Path) String() string { return string(p) }
